



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python程序数据溢出问题或出现 NAN 问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python程序数据溢出问题或出现 NAN 问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:07:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>【数据溢出问题】</p>
<p>overflow：溢出</p>
<ul><li>overflow：上溢</li>
<li>underflow：下溢</li></ul>
<div>数据溢出包括上溢和下溢。</div>
<div>上溢可以理解为：你想用一个int类型来保存一个非常非常大的数，而这个超出了int类型所能表示的最大的数的范围。</div>
<div>下溢同理：你要用double来表示一个非常非常小的数，超出它所能表示的最小数时，就会发生数据溢出错误。</div>
<div>&nbsp;</div>
<p>【如何避免Python程序下溢问题】</p>
<div>浮点数的下溢一般是由很多很小的数（如很多独立同分布数据的概率相乘）的连乘造成的，连乘后的数值有时候会达到负几十万个指数级。</div>
<div>&nbsp;</div>
<div>其中一个解决办法是：对这个累乘的乘积<strong>取自然对数</strong>，可以将连乘化为求和：</div>
<div>在对数中有：</div>
<div><img referrerpolicy="no-referrer"src="/Users/ADMINI~1/AppData/Local/Temp/enhtmlclip/Image.png" /></div>
<div>&nbsp;<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/818082/201803/818082-20180321193212261-218140515.png" /></p>
</div>
<div>这样即可避免浮点数的下溢，但是要记得最后要<strong>取回来</strong>（取对数）。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>【老板给：<a href="https://hips.seas.harvard.edu/blog/2013/01/09/computing-log-sum-exp/" rel="external nofollow noreferrer">Computing Log-Sum-Exp</a>180711】</div>
<div>　　The "nan problem" is not due to the inference method but instead to a poor implementation of it. Since machines have limited precision, certain types of calculations involving many numbers in a different scale tend to <strong>underflow</strong> or <strong>overflow</strong>.<br />　　If you have written the inference code by yourself, please make sure you are <strong>not doing products of</strong> probabilities to compute likelihoods, but instead, <strong>sum of logarithms</strong>. And even that, make sure your log-likelihood does not become -infinity (resulting in a "nan" value).</div>
<div>&nbsp;</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2o4kx9.html">POJ1737 Connected Graph</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o73zeq.html">java将白色背景图片转换成无色</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxl2n9.html">EM算法原理以及高斯混合模型实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlr269.html">Reflect</a>
		</li>
						<li><a href="https://www.batexi.com/a/96omr039.html">hdu - 1240 Nightmare &amp;amp&semi;&amp;amp&semi; hdu - 1253 胜利大逃亡&lpar;bfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzwxv8.html">contentProvider-联系人的CURD</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv3wozq.html">了解常见的 Azure 灾难</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ow4lq.html">javascript 关于闭包的知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmljml9.html">Hadoop CLI MiniCluster</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpj3k69.html">springMVC之数据传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzejvl8.html">updateMany</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z4pg09.html">UVA 11021 &sol;概率</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmlxr9.html">http的状态码（中英文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpd6yvq.html">C语言 extern学习1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj57169.html">【转】深入理解RunLoop</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2gklq.html">（转）java中的方法区</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg2zoq.html">证明与计算&lpar;4&rpar;&colon; 完美散列函数&lpar;Perfect Hash function&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25x1xlq.html">Educational Codeforces Round 53 &lpar;Rated for Div&period; 2&rpar; D&period; Berland Fair</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw2ndd8.html">java反编译工具cfr</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j65x3q.html">python第六十三天-- 第十一周作业</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/953y2pm8.html">&lbrack;转&rsqb;C&plus;&plus;之多态性与虚函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjln20q.html">金蝶KIS下载地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjlmezq.html">第一章 Java代码执行流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pk0rn8.html">C&num;中HTML和UBB互相转换的代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlekzk9.html">Sql Server的弱口令入侵测试以及防范</a>
			</li>
						<li><a href="https://www.batexi.com/a/953vrnz8.html">Android -- SDcard文件读取和保存</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvld1xq.html">nodejs自动热加载文件的做法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppywmd9.html">ufldl学习笔记与编程作业：Softmax Regression&lpar;vectorization加速&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnkv5gq.html">maven command to create your application</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmrmww9.html">H面试（23）：求子数组最大和</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
